<?php
function __autoload($class)
{
  if (!defined('CLASS_PATH')) throw new Exception('Class path not defined');

  $fname = CLASS_PATH . '/'.strtolower($class).'.class.php';

  if (!file_exists($fname)) throw new Exception(sprintf('Class %s not found', $class));

  require_once($fname);
}

function json_return($data)
{
  header('Content-type: application/json; charset="UTF-8"');

  $encoded = json_encode($data);

  if ($encoded === false) {
    error_log('Encoding error, return ' . var_export($data,true));
    echo json_encode(array('status' => false,
			   'error' => 'Die Rückgabedaten können nicht kodiert werden.'));
  } else
    echo $encoded;

  exit();
}

function ajax_error($text)
{
  $data = array('status' => false, 'error' => $text);
  json_return($data);
}

function assert_iso_date($date)
{
  if (strpos($date, '.') === false) return $date;
  $d = explode('.', $date);
  return $d[2] . '-' . $d[1] . '-' . $d[0];
}

function assert_german_date($date)
{
  if (is_null($date)) return '';
  if (strpos($date, '-') === false) return $date;
  $d = explode('-', $date);
  return $d[2] . '.' . $d[1] . '.' . $d[0];
}

global $db;

$dsn = sprintf('%s:host=%s;dbname=%s', DBDRIVER, DBHOST, DBNAME);
$db = new Database(DBDRIVER, DBHOST, DBNAME, DBUSER, DBPASS);
if (defined('MAIL_ERROR')) $db->setErrorMail(MAIL_ERROR);
?>
